(* An abstract syntax tree for WPPL programs with types
   Copyright (C) 2007 Jay McCarthy
*)

open Pos

type id = pos * string
let id_eq (_, s0) (_, s1) = s0 = s1

type id_type = 
    Name of pos
    | Text of pos
    | Msg of pos
    | Nonce of pos
    | Pubkey of pos
    | Symkey of pos
    | Channel of pos

let type2str t =
  match t with
      Name _ -> "name"
    | Text _ -> "text"
    | Msg _ -> "msg"
    | Nonce _ -> "nonce"
    | Pubkey _ -> "pubkey"
    | Symkey _ -> "symkey"
    | Channel _ -> "channel"

type role = id
let role_eq = id_eq

type new_type =
    New_nonce of pos
    | New_symkey of pos
    | New_pubkey of pos
let new_type_to_id_type = function
  | New_nonce p -> Nonce p
  | New_symkey p -> Symkey p
  | New_pubkey p -> Pubkey p
