(*  
 // hwang modified version of neumann stubblebine 
  
 a, b, s :          principal 
 na, ma, nb, mb :   number    
 kas, kbs, kab :    key       
 ta, tb :           time      
  
  
 1.   a -> b  :   a, na                                    
 2.   b -> s  :   b, {a, na, tb, nb}kbs                    
 3.   s -> a  :   {b, na, kab, tb}kas, {a, kab, tb}kbs, nb 
 4.   a -> b  :   {a, kab, tb}kbs, {nb}kab                 
 5.   a -> b  :   ma, {a, kab, tb}kbs                      
 6.   b -> a  :   mb, {mb}kab                              
 7.   a -> b  :   {mb}kab                                  
   
 // security protocols open repository 
 // http://www.lsv.ens-cachan.fr/spore 
*)
(spec
 ([a (a:name b:name s:name kas:symkey) (kab:symkey)]
  [b (b:name s:name kbs:symkey) (kab:symkey)]
  [s (a:name b:name s:name kas:symkey kbs:symkey) (kab:symkey)])

 [a -> b : a, na:nonce]
 [b -> s : b, {|a, na, tb:nonce, nb:nonce|} kbs]
 [s -> a : {|b, na, kab:symkey, tb|} kas, {|a, kab, tb|} kbs, nb]
 [a -> b : {|a, kab, tb|} kbs, {|nb|} kab]
 (* [a -> b : ma:nonce, {|a, kab, tb|} kbs]
 [b -> a : mb:nonce, {|ma|} kab]
 [a -> b : {|mb|} kab] *)
 .)
