(* Helpers for WPPL msgs and terms
   Copyright (C) 2007 Jay McCarthy
*)

open Ast_ut
open Env

let undecl_bindings renv d =
  let ((_,ids), _) = d in
    if PMap.mem ids renv then
      []
    else
      [ d ]

let unfdecl_bindings renv d =
  match d with
    | ULogicV v -> undecl_bindings renv v
    | UDataV _ -> []

let unterm_bindings renv = function
  | UTerm (_, ds) ->
      List.fold_left
	(fun bs t ->
	  (unfdecl_bindings renv t) @ bs)
	[]
	ds  

